src/main/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('todo.urls')),
    path('admin/', admin.site.urls),
]

src/todo/urls.py
from django.urls import path

from . import views

app_name = 'todo'
urlpatterns = [
    path('', views.index, name='index'),
    path('<int:todo_id>/todo', views.todo, name='todo'),
    path('todo_new', views.todo_new, name='todo_new'),
    path('<int:todo_id>/todo_save', views.todo_save, name='todo_save'),
    path('<int:todo_id>/todo_delete', views.todo_delete, name='todo_delete'),
]

src/todo/models.py
from django.db import models


class Todo(models.Model):
    todo_text = models.CharField(max_length=255)

    def __str__(self):
        return self.todo_text

src/todo/forms.py
from django import forms


class TodoForm(forms.Form):
    id = forms.IntegerField()
    todo_text = forms.CharField()

src/todo/views.py
from django.http import Http404, HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse

from .forms import TodoForm
from .models import Todo


def index(request):
    # show the first 10 todos
    todos = Todo.objects.order_by('id')[:10]
    return render(request, 'index.html', {
        'todos': todos
    })


def todo(request, todo_id):
    try:
        todo = Todo.objects.get(pk=todo_id)
    except Todo.DoesNotExist:
        raise Http404('Question does not exist')
    return render(request, 'todo.html', {
        'todo': todo
    })


def todo_new(request):
    return render(request, 'todo_new.html')


def todo_save(request, todo_id):
    if request.method == 'POST':
        form = TodoForm(request.POST)
        todo_text = form.data['todo_text']

        if todo_id == 0:
            todo = Todo.objects.create(todo_text=todo_text)
            todo.save()

        try:
            todo = Todo.objects.get(pk=todo_id)
            todo.todo_text = todo_text
            todo.save()
        except Todo.DoesNotExist as ex:
            print(ex)

    return HttpResponseRedirect(reverse('todo:index'))


def todo_delete(request, todo_id):
    try:
        todo = Todo.objects.get(pk=todo_id)
        todo.delete()
    except Todo.DoesNotExist as ex:
        print(ex)

    return HttpResponseRedirect(reverse('todo:index'))

src/templates/base.html
<!DOCTYPE html>
{% load static %}
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>TODO</title>
    <link href="{% static '/css/bootstrap.min.css' %}" rel="stylesheet">
</head>
<body>
<div class="container">
    <div class="row">
        <div class="col-md-6 md-auto">
            {% block content %}{% endblock %}
        </div>
    </div>
</div>
<script src="{% static 'js/bootstrap.min.js' %}"></script>
</body>
</html>

src/templates/index.html
{% extends 'base.html' %}

{% block content %}
    <h1 class="text-center mb-3">
        TODO
    </h1>

    <div class="text-end mb-3">
        <a href="{% url 'todo:todo_new' %}" class="btn btn-primary">New</a>
    </div>

    {% if todos %}
        {% for todo in todos %}
            <div class="card mb-3">
                <div class="card-body">
                    <div class="card-text">
                        <a href="{% url 'todo:todo' todo.id %}">{{ todo.todo_text }}</a>
                        <div class="float-end">
                            <a href="{% url 'todo:todo_delete' todo.id %}" class="btn btn-danger">Delete</a>
                        </div>
                    </div>
                </div>
            </div>
        {% endfor %}
    {% endif %}

{% endblock %}

src/templates/todo.html
{% extends 'base.html' %}

{% block content %}
    <a href="{% url 'todo:index' %}" class="btn btn-secondary mt-3 mb-3">Go Back</a>
    <div class="card">
        <div class="card-body">
            <div class="card-text">
                <form action="{% url 'todo:todo_save' todo.id %}" method="post">
                    <div class="mb-3">
                        <label for="todo_text" class="fs-2">TODO #{{ todo.id }}</label>
                        <textarea name="todo_text" id="todo_text" class="form-control" cols="60"
                                  rows="20">{{ todo.todo_text }}</textarea>
                    </div>
                    {% csrf_token %}
                    {{ form }}
                    <input type="submit" value="Save" class="btn btn-success btn-lg float-end"/>
                </form>
            </div>
        </div>
    </div>
{% endblock %}

src/templates/todo_new.html
{% extends 'base.html' %}

{% block content %}
    <a href="{% url 'todo:index' %}" class="btn btn-secondary mt-3 mb-3">Go Back</a>
    <div class="card">
        <div class="card-body">
            <div class="card-text">
                <form action="{% url 'todo:todo_save' 0 %}" method="post">
                    <div class="mb-3">
                        <label for="todo_text" class="fs-2">NEW TODO</label>
                        <textarea name="todo_text" id="todo_text" class="form-control" cols="60"
                                  rows="20">{{ todo.todo_text }}</textarea>
                    </div>
                    {% csrf_token %}
                    {{ form }}
                    <input type="submit" value="Save" class="btn btn-success btn-lg float-end"/>
                </form>
            </div>
        </div>
    </div>
{% endblock %}